#

![jsPsych](img/jspsych-logo.jpg)

jsPsych is a JavaScript framework for creating behavioral experiments that run in a web browser. 

Experiments in jsPsych are created using [plugins](overview/plugins.md).
Each plugin defines different kinds of events, like showing an image on the screen, and collects different kinds of data, like recording which key was pressed at which time. 
You can use the plugins that are [included with jsPsych](plugins/list-of-plugins.md), use plugins that are developed by community members in the [contrib repository](https://github.com/jspsych/jspsych-contrib), or [create your own plugins](developers/plugin-development.md).
By assembling different plugins together into [a timeline](overview/timeline.md), it is possible to create a wide range of experiments.

[The page on timelines](overview/timeline.md) is a good place to start learning about jsPsych. 
From there, you might want to complete the [hello world tutorial](tutorials/hello-world.md) to learn how to set up a jsPsych experiment and the [reaction time experiment tutorial](tutorials/rt-task.md) to learn the core features of the framework.
